// ==UserScript==
// @name All Block
// @author Lex1
// @version 1.3.14
// @description Block embedded content (Flash, Java, etc). For Opera 9.5+. Press Ctrl+Shift+F or Ctrl+Alt+F for permanent unblocking on the site.
// @ujs:documentation http://ruzanow.ru/index/0-5
// @ujs:download http://ruzanow.ru/userjs/allblock-lite.js
// @exclude file://*
// @exclude http://mail.google.com/*
// @exclude http://files.mail.ru/*
// @exclude http://*megaupload.com/*
// @exclude http://*blizzard.com/*
// @exclude http://*.acidtests.org/*
// @exclude http://*.operaunite.com/media_player/*
// @exclude http://example.com/*
// ==/UserScript==

(function(){
	var prefix = 'ujs_flashblock', cName = prefix+'_disabled';
	var css = 'object:not(.'+cName+'),embed:not(.'+cName+'),applet:not(.'+cName+'){content: "" !important; display: inline-block !important; outline: 1px dotted #bbbbbb !important; min-width: 33px !important; min-height: 33px !important; cursor: pointer !important; background: -o-skin("Extender Right Arrow") !important;} object:hover:not(.'+cName+'),embed:hover:not(.'+cName+'),applet:hover:not(.'+cName+'){opacity: 0.7 !important;}';

	var addStyle = function(css){
		var s = document.createElement('style');
		s.setAttribute('type', 'text/css');
		s.setAttribute('style', 'display: none !important;');
		s.appendChild(document.createTextNode(css));
		return (document.getElementsByTagName('head')[0] || document.documentElement).appendChild(s);
	};

	var getValue = function(name){
		if(window.localStorage){
			return window.localStorage.getItem(name) || '';
		}
		else{
			var eq = name+'=', ca = document.cookie.split(';');
			for(var i = ca.length; i--;){
				var c = ca[i];
				while(c.charAt(0) == ' ')c = c.slice(1);
				if(c.indexOf(eq) == 0)return unescape(c.slice(eq.length));
			};
			return '';
		}
	};

	var setValue = function(name, value, del){
		if(window.localStorage){
			if(del){window.localStorage.removeItem(name)}else{window.localStorage.setItem(name, value)};
		}
		else{
			if(document.cookie.split(';').length < 30 && document.cookie.length-escape(getValue(name)).length+escape(value).length < 4000){
				var date = new Date();
				date.setTime(date.getTime()+((del ? -1 : 10*365)*24*60*60*1000));
				document.cookie = name+'='+escape(value)+'; expires='+date.toGMTString()+'; path=/';
			}
			else{
				alert('Cookies is full!');
			}
		}
	};

	var getVideo = function(flashvars, src){
		var getLink = function(s){var rez = s.match(/[^\s\x22=&?]+\.[^\s\x22=&?\/]*(flv|mp4)/i); return rez ? rez[0] : ''};
		var getQuery = function(s, q){var rez = s.match(new RegExp('[&?]'+q+'=([^&]+)')); return rez ? rez[1] : ''};
		var getJson = function(s, q){var rez = s.match(new RegExp('\x22'+q+'\x22:\\s*(\x22.+?\x22)')); return rez ? eval(rez[1]) : ''};
		var getXml = function(s, t){var x = new XMLHttpRequest(); x.open('GET', s, false); x.send(null); return x.responseXML && x.responseXML.getElementsByTagName(t)[0]};
		var getURL = function(f, s){return f.match(/^(\w+:\/\/|\/|$)/) ? f : s.replace(/[#?].*$/, '').replace(/[^\/]*$/, f)};
		var decodeURL = function(s){try{return decodeURIComponent(s)}catch(e){return unescape(s)}};

		var q = '', url = location.href, flv = decodeURL(flashvars);

		if( url.indexOf('youtube.com/watch?') != -1 && (q = decodeURL(getQuery(flashvars, 'fmt_url_map')).match(/\d{2}\|([^,]+)/)) )return q[1]+'&title='+encodeURIComponent(document.title);
		if( url.indexOf('video.google.com/videoplay?') != -1 && (q = getQuery(src, 'videoUrl')) )return decodeURL(q);
		if( url.indexOf('metacafe.com/watch/') != -1 && (q = getQuery(flv, 'mediaURL')) )return q+'?__gda__='+getQuery(flv, 'gdaKey');
		if( url.indexOf('dailymotion.com/') != -1 && (q = getJson(flv, 'hqURL') || getJson(flv, 'sdURL')) )return q;
		if( url.indexOf('my-hit.ru/film/') != -1 && (q = getLink(flv)) )return q+'?start=0&id='+getQuery(flv, 'id');
		if( url.indexOf('vd.reborn.ru/?a=watch') != -1 && (q = getQuery(src, 'filename')) )return 'http://flv.reborn.ru:81/'+q+'.flv';
		if( url.indexOf('vision.rambler.ru/') != -1 && (q = getXml(url+'flash_basic_data.xml?where=video', 'flv')) )return q.firstChild.nodeValue;

		return getURL(getLink(flv) || decodeURL(getLink(src)), src);
	};

	var getParam = function(e, n){
		var v = '', r = new RegExp('^('+n+')$', 'i');
		var param = e.getElementsByTagName('param');
		for(var i = 0, p; p = param[i]; i++){
			if(p.hasAttribute('name') && p.getAttribute('name').match(r)){v = p.getAttribute('value'); break};
		};
		return v;
	};

	var qualifyURL=function(url){
		if(!url)return '';
		var a = document.createElement('a');
		a.href = url;
		return a.href;
	};

	var addClassName = function(ele, cName){
		ele.className += (ele.className ? ' ' : '')+cName;
	};

	var delClassName = function(ele, cName){
		var a = ele.className.split(' ');
		for(var i = a.length; i--;){
			if(a[i] == cName)a.splice(i, 1);
		};
		ele.className = a.join(' ');
	};

	var isBlocked = function(ele){
		var tag = ele && ele.nodeName.toLowerCase();
		return (tag == 'embed' || tag == 'object' || tag == 'applet') && (ele.currentStyle.content || getComputedStyle(ele, null).content) == '""';
	};

	var setStatus = function(value){
		if(top == self){
			window.status = value;
			window.defaultStatus = value;
			window.setTimeout(function(){window.defaultStatus = ''}, 4000);
		}
	};

	var delStyle = function(css){
		var styles = document.getElementsByTagName('style');
		for(var i = styles.length; i--;){
			if(styles[i].innerHTML == css)styles[i].parentNode.removeChild(styles[i]);
		}
	};

	var getLng = function(){
		switch(window.navigator.language){
			case 'ru': return {
				fEnabled: 'AllBlock \u0432\u043A\u043B\u044E\u0447\u0435\u043D',
				fDisabled: 'AllBlock \u0432\u044B\u043A\u043B\u044E\u0447\u0435\u043D'
			};
			default: return {
				fEnabled: 'AllBlock enabled',
				fDisabled: 'AllBlock disabled'
			}
		}
	};

	var unblockFlash = function(e){
		var ele = e && e.target; if(!ele)return;
		var embed = ele.getElementsByTagName('embed')[0];
		if(isBlocked(ele) && !e.shiftKey && !e.altKey){
			e.preventDefault();
			e.stopPropagation();

			var src = ele.getAttribute('src') || ele.getAttribute('source') || ele.getAttribute('data') || getParam(ele, 'movie|data|src|code|filename|url|source') || (embed && embed.getAttribute('src')) || '';
			if(e.ctrlKey){
				// Save video with Ctrl+Click
				if(src)location.href = getVideo(ele.getAttribute('flashvars') || getParam(ele, 'flashvars'), src) || src;
			}
			else{
				// Unblock flash
				addClassName(ele, cName);
				if(isBlocked(embed))addClassName(embed, cName);
				if(ele.getAttribute('title') == qualifyURL(src))ele.removeAttribute('title');
			}
		}
	};

	var showAddress = function(e){
		var ele = e && e.target; if(!ele)return;
		if(!ele.title && isBlocked(ele)){
			var src = ele.getAttribute('src') || ele.getAttribute('source') || ele.getAttribute('data') || getParam(ele, 'movie|data|src|code|filename|url|source');
			if(src)ele.setAttribute('title', qualifyURL(src));
		}
	};

	var toggle = function(block){
		var postMsg = function(msg){for(var i = 0, f = window.frames, l = f.length; i < l; i++)f[i].postMessage(msg, '*')};
		var lng = getLng();
		if(arguments.length ? !block : getValue(prefix) != 'unblocked'){
			delStyle(css);
			setValue(prefix, 'unblocked');
			postMsg(prefix+'_disable');
			document.removeEventListener('click', unblockFlash, true);
			document.removeEventListener('mouseover', showAddress, false);
			setStatus(lng.fDisabled);
		}
		else{
			addStyle(css);
			setValue(prefix, '', true);
			postMsg(prefix+'_enable');
			document.addEventListener('click', unblockFlash, true);
			document.addEventListener('mouseover', showAddress, false);
			setStatus(lng.fEnabled);
		};
		var unblockedEle = document.getElementsByClassName(cName);
		for(var i = unblockedEle.length; i--;){
			delClassName(unblockedEle[i], cName);
		}
	};


	// Non html
	if(!(document.documentElement instanceof HTMLHtmlElement))return;

	// Blocking
	if(getValue(prefix) != 'unblocked'){
		addStyle(css);
		// unblock flash
		document.addEventListener('click', unblockFlash, true);
		// show title
		document.addEventListener('mouseover', showAddress, false);
	};

	// Unblock for the site with Ctrl+Shift+F or Ctrl+Alt+F
	document.addEventListener('keypress', function(e){
		if(e.keyCode == 70 && e.ctrlKey && (e.shiftKey != e.altKey))toggle();
	}, false);

	// For buttons
	window.addEventListener('message', function(e){
		if(e.data == prefix+'_disable')toggle(false);
		if(e.data == prefix+'_enable')toggle(true);
	}, false);
})();
